package no.officenet.example.eclipselink.abstraccolmapping;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "message")
@SequenceGenerator(name = "EmailPartSEQ_STORE", sequenceName = "email_part_entity_id_seq", allocationSize = 1)
public class Message {

	public Message() {
	}

	public Message(String subject) {
		this.subject = subject;
	}

	@Id
	@Column(name = "id")
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "EmailPartSEQ_STORE")
	public Long id = null;

	@Column(name = "subject")
	public String subject;

	@OneToMany(mappedBy = "message")
	@OrderBy("id")
	public List<Part> partList = new ArrayList<>();

	public void addPart(Part part) {
		part.message = this;
		partList.add(part);
	}

}
