package no.officenet.example.eclipselink.abstraccolmapping;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

@Entity
@Table(name = "part")
@SequenceGenerator(name = "PartSEQ_STORE", sequenceName = "email_part_entity_id_seq", allocationSize = 1)
public class Part {

	public Part() {
	}

	public Part(String content) {
		this.content = content;
	}

	@Id
	@Column(name = "id")
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "PartSEQ_STORE")
	public Long id = null;

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "message_id")
	public Message message;

	@Column(name = "content")
	@Basic(optional = false)
	public String content;

}
