package no.officenet.example.eclipselink.abstraccolmapping;

import org.testng.Assert;
import org.testng.annotations.Test;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

@Test
public class MessageTest {

	public void testFails() throws Exception {
		EntityManagerFactory entityManagerFactory = Persistence.createEntityManagerFactory("fish");
		EntityManager em = entityManagerFactory.createEntityManager();
		em.getTransaction().begin();
		Message message = new Message("Test message");
		message.addPart(new Part("Test content1"));
		message.addPart(new Part("Test content2"));
		message.addPart(new Part("Test content3"));
		em.merge(message);
		em.getTransaction().commit();
		em.clear();

		em.getTransaction().begin();
		message = em.find(Message.class, 1L);
		String updatedContent = "Updated";
		message.partList.get(0).content = updatedContent;
		em.getTransaction().commit();
		em.clear();

		message = em.find(Message.class, 1L);
		System.out.println(message.partList.get(0).content);

		Assert.assertNotEquals(message.partList.get(0).content, updatedContent);
		Assert.assertNotEquals(message.partList.size(), 3, "Should not have 3 parts as the mapping is not cascading");
	}

}
